#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	cmocka
Version		:	1.1.5
Release		:	14.4.0.0%{?dist}
Summary		:	An elegant unit testing framework for C with support for mock objects

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	ASL 2.0
URL		:	https://cmocka.org

Source0		:	%{name}-%{version}.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	cmake
BuildRequires	:	doxygen
BuildRequires	:	gcc
BuildRequires	:	glibc
BuildRequires	:	gnupg
#-----------------------------------------------------------------------------
%description
There are a variety of C unit testing frameworks available however many of them
are fairly complex and require the latest compiler technology. Some development
requires the use of old compilers which makes it difficult to use some unit
testing frameworks. In addition many unit testing frameworks assume the code
being tested is an application or module that is targeted to the same platform
that will ultimately execute the test. Because of this assumption many
frameworks require the inclusion of standard C library headers in the code
module being tested which may collide with the custom or incomplete
implementation of the C library utilized by the code under test.
 
Cmocka only requires a test application is linked with the standard C library
which minimizes conflicts with standard C library headers. Also, CMocka tries
to avoid the use of some of the newer features of C compilers.
 
This results in CMocka being a relatively small library that can be used to
test a variety of exotic code. If a developer wishes to simply test an
application with the latest compiler then other unit testing frameworks may be
preferable.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc AUTHORS README.md ChangeLog
%license COPYING
%{_libdir}/libcmocka.so.*
 
#=============================================================================
%package		devel
Summary		:	Development headers for the cmocka library

Requires	:	%{name}		= %{version}-%{release}
 
#-----------------------------------------------------------------------------
%description		devel
Development headers for the cmocka unit testing library.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}.h
%{_includedir}/%{name}_pbc.h
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/cmake/%{name}/%{name}-config-version.cmake
%{_libdir}/cmake/%{name}/%{name}-config.cmake

#=============================================================================
%prep
%setup -q


#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	.						\
	-B build					\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D CMAKE_INSTALL_LIBDIR=lib			\
	-D CMAKE_BUILD_TYPE=Release			\
	-D UNIT_TESTING=ON				\
 

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	-C build					\
	%{_smp_mflags}


#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install

%{__rm} -rf %{buildroot}
%{__make}						\
	-C build					\
	DESTDIR="%{buildroot}"				\
	install

#-----------------------------------------------------------------------------
%changelog
